(function(factory,window){if(typeof define==='function'&&define.amd){define(['leaflet'],factory)}else if(typeof exports==='object'){module.exports=factory(require('leaflet'))}
if(typeof window!=='undefined'&&window.L){factory(L)}}(function(L){'use strict';var regStyle=/([\w-]+): ([^;]+);/g,css3_transforms={transform:'transform',WebkitTransform:'-webkit-transform',OTransform:'-o-transform',MozTransform:'-moz-transform',msTransform:'-ms-transform'},transform=css3_transforms[L.DomUtil.TRANSFORM],_bouncingMotionsCache={};function parseCssText(cssText){var styleDefinitions={},match=regStyle.exec(cssText);while(match){styleDefinitions[match[1]]=match[2];match=regStyle.exec(cssText)}
return styleDefinitions}
function renderCssText(styleDefinitions){var cssText='',key;for(key in styleDefinitions){cssText+=key+': '+styleDefinitions[key]+'; '}
return cssText}
function calculateLine(x,y,angle,length){var xD=Math.round(x+Math.cos(angle)*(length*2)),yD=Math.round(y+Math.sin(angle)*(length*2)),dx=Math.abs(xD-x),sx=x<xD?1:-1,dy=Math.abs(yD-y),sy=y<yD?1:-1,err=(dx>dy?dx:-dy)/2,e2,p=[],i=0;while(!0){p.push([x,y]);i++;if(i===length)
break;e2=err;if(e2>-dx){err-=dy;x+=sx}
if(e2<dy){err+=dx;y+=sy}}
return p}
function calculateIconMovePoints(x,y,bounceHeight){var p=[],dH=bounceHeight+1;while(dH--){p[dH]=[x,y-dH]}
return p}
function calculateShadowMovePoints(x,y,bounceHeight,angle){if(angle!=null){return calculateLine(x,y,angle,bounceHeight+1)}else{for(var p=[],i=0;i<=bounceHeight;i++){p[i]=[x,y]}
return p}}
function calculateIconMoveTransforms(x,y,bounceHeight){var t=[],dY=bounceHeight+1;while(dY--){t[dY]=' matrix3d(1,0,0,0,0,1,0,0,0,0,1,0,'+x+','+(y-dY)+',0,1) '}
return t}
function calculateShadowMoveTransforms(x,y,bounceHeight,angle){var t=[],dY=bounceHeight+1;if(angle!=null){var p=calculateLine(x,y,angle,bounceHeight+1)}else{for(var p=[],i=0;i<=bounceHeight;i++){p[i]=[x,y]}}
while(dY--){t[dY]=' matrix3d(1,0,0,0,0,1,0,0,0,0,1,0,'+p[dY][0]+','+p[dY][1]+',0,1) '}
return t}
function calculateIconResizeTransforms(x,y,height,contractHeight){var t=[],dH=contractHeight+1;while(dH--){t[dH]=' matrix3d(1,0,0,0,0,'+((height-dH)/height)+',0,0,0,0,1,0,'+x+','+(y+dH)+',0,1) '}
return t}
function calculateShadowResizeTransforms(x,y,width,height,contractHeight,angle){var t=[],p=calculateLine(width,height,angle+Math.PI,contractHeight),dH=contractHeight+1;while(dH--){t[dH]=' matrix3d('+(width/p[dH][0])+',0,0,0,0,'+(p[dH][1]/height)+',0,0,0,0,1,0,'+x+','+(y+height-p[dH][1])+',0,1) '}
return t}
function calculateSteps(height,prefix){var key=prefix+height,steps=[],i;if(_bouncingMotionsCache[key]){return _bouncingMotionsCache[key]}
i=1;while(i<=height){steps.push(i++)}
i=height;while(i--){steps.push(i)}
_bouncingMotionsCache[key]=steps;return steps}
function calculateDelays(height,speed,prefix){var key=prefix+height+'_'+speed,deltas=[],delays=[],totalDelay=0,l,i;if(_bouncingMotionsCache[key]){return _bouncingMotionsCache[key]}
deltas[height]=speed;deltas[0]=0;i=height;while(--i){deltas[i]=Math.round(speed/(height-i))}
i=height;while(i--){deltas.push(deltas[i])}
for(i=0,l=deltas.length;i<l;i++){totalDelay+=deltas[i];delays.push(totalDelay)}
_bouncingMotionsCache[key]=delays;return delays}
L.Marker._bouncingMarkers=[];L.Marker.setBouncingOptions=function(options){L.extend(L.Marker.prototype._bouncingOptions,options)};L.Marker.getBouncingMarkers=function(){return L.Marker._bouncingMarkers};L.Marker.stopAllBouncingMarkers=function(){var marker;while(marker=L.Marker._bouncingMarkers.shift()){marker._bouncingMotion.isBouncing=!1}};L.Marker._addBouncingMarker=function(marker,exclusive){if(exclusive||marker._bouncingOptions.exclusive){L.Marker.stopAllBouncingMarkers()}else{L.Marker._stopEclusiveMarkerBouncing()}
L.Marker._bouncingMarkers.push(marker)};L.Marker._removeBouncingMarker=function(marker){var i=L.Marker._bouncingMarkers.length;if(i){while(i--){if(L.Marker._bouncingMarkers[i]==marker){L.Marker._bouncingMarkers.splice(i,1);break}}}};L.Marker._stopEclusiveMarkerBouncing=function(){var i=L.Marker._bouncingMarkers.length;if(i){while(i--){if(L.Marker._bouncingMarkers[i]._bouncingOptions.exclusive){L.Marker._bouncingMarkers[i]._bouncingMotion.isBouncing=!1;L.Marker._bouncingMarkers.splice(i,1)}}}};L.Marker.include({_bouncingOptions:{bounceHeight:15,contractHeight:12,bounceSpeed:52,contractSpeed:52,shadowAngle:-Math.PI/4,elastic:!0,exclusive:!1,},setBouncingOptions:function(options){if(!this.hasOwnProperty('_bouncingOptions')){this._bouncingOptions=L.extend({},L.Marker.prototype._bouncingOptions)}
L.extend(this._bouncingOptions,options);this._calculateTimeline();this._calculateTransforms();return this},isBouncing:function(){return this._bouncingMotion.isBouncing},bounce:function(){var marker=this,icon=this._icon,shadow=this._shadow,bouncingOptions=marker._bouncingOptions,motion=marker._bouncingMotion,bounceHeight=bouncingOptions.bounceHeight,contractHeight=bouncingOptions.contractHeight,bounceSpeed=bouncingOptions.bounceSpeed,contractSpeed=bouncingOptions.contractSpeed,shadowAngle=bouncingOptions.shadowAngle,elastic=bouncingOptions.elastic,exclusive=bouncingOptions.exclusive,moveSteps=motion.moveSteps,moveDelays=motion.moveDelays,resizeSteps=motion.resizeSteps,resizeDelays=motion.resizeDelays,nbMoveSteps=moveSteps.length,nbResizeSteps=resizeSteps.length,baseIconCssText=motion.baseIconCssText,baseShadowCssText=motion.baseShadowCssText,is3d=L.Browser.any3d,times=null;if(motion.bouncingAnimationPlaying){motion.isBouncing=!0;return}
if(arguments.length==1){times=arguments[0]}
function makeMoveStep(step){icon.style.cssText=baseIconCssText+'z-index: '+marker._zIndex+';'+transform+': '+motion.iconMoveTransforms[step];if(shadow){shadow.style.cssText=baseShadowCssText+transform+': '+motion.shadowMoveTransforms[step]}}
function makeMoveStepNo3D(step){icon.style.cssText=baseIconCssText+'z-index: '+marker._zIndex+';';icon.style.left=motion.iconMovePoints[step][0]+'px';icon.style.top=motion.iconMovePoints[step][1]+'px';if(shadow){shadow.style.cssText=baseShadowCssText;shadow.style.left=motion.shadowMovePoints[step][0]+'px';shadow.style.top=motion.shadowMovePoints[step][1]+'px'}}
function makeResizeStep(step){icon.style.cssText=baseIconCssText+'z-index: '+marker._zIndex+';'+transform+': '+motion.iconResizeTransforms[step];if(shadow&&shadowAngle!=null){shadow.style.cssText=baseShadowCssText+transform+': '+motion.shadowResizeTransforms[step]}}
function move(){if(times!==null){if(!--times){motion.isBouncing=!1;motion.bouncingAnimationPlaying=!1}}
var i=nbMoveSteps;if(is3d){while(i--){setTimeout(makeMoveStep,moveDelays[i],moveSteps[i])}}else{while(i--){setTimeout(makeMoveStepNo3D,moveDelays[i],moveSteps[i])}}
setTimeout(function(){if(elastic&&is3d){resize()}else if(motion.isBouncing){setTimeout(move,bounceSpeed)}else{motion.bouncingAnimationPlaying=!1}},moveDelays[nbMoveSteps-1])}
function resize(){var i=nbResizeSteps;setTimeout(function(){if(!motion.isBouncing){motion.bouncingAnimationPlaying=!1}},resizeDelays[i]);while(i--){setTimeout(makeResizeStep,resizeDelays[i],resizeSteps[i])}
setTimeout(function(){if(motion.isBouncing){move()}},resizeDelays[nbResizeSteps-1])}
L.Marker._addBouncingMarker(marker,exclusive);motion.isBouncing=!0;motion.bouncingAnimationPlaying=!0;move();return marker},stopBouncing:function(){this._bouncingMotion.isBouncing=!1;L.Marker._removeBouncingMarker(this);return this},toggleBouncing:function(){if(this._bouncingMotion.isBouncing){this.stopBouncing()}else{this.bounce()}
return this},_calculateTimeline:function(){this._bouncingMotion.moveSteps=calculateSteps(this._bouncingOptions.bounceHeight,'moveSteps_');this._bouncingMotion.moveDelays=calculateDelays(this._bouncingOptions.bounceHeight,this._bouncingOptions.bounceSpeed,'moveDelays_');if(this._bouncingOptions.elastic){this._bouncingMotion.resizeSteps=calculateSteps(this._bouncingOptions.contractHeight,'resizeSteps_');this._bouncingMotion.resizeDelays=calculateDelays(this._bouncingOptions.contractHeight,this._bouncingOptions.contractSpeed,'resizeDelays_')}},_calculateTransforms:function(){if(L.Browser.any3d){if(this.options.icon.options.iconSize){var iconHeight=this.options.icon.options.iconSize[1]}else{var iconHeight=this._iconObj.options.iconSize[1]}
this._bouncingMotion.iconMoveTransforms=calculateIconMoveTransforms(this._bouncingMotion.x,this._bouncingMotion.y,this._bouncingOptions.bounceHeight);this._bouncingMotion.iconResizeTransforms=calculateIconResizeTransforms(this._bouncingMotion.x,this._bouncingMotion.y,iconHeight,this._bouncingOptions.contractHeight);if(this._shadow){this._bouncingMotion.shadowMoveTransforms=calculateShadowMoveTransforms(this._bouncingMotion.x,this._bouncingMotion.y,this._bouncingOptions.bounceHeight,this._bouncingOptions.shadowAngle);this._bouncingMotion.shadowResizeTransforms=calculateIconResizeTransforms(this._bouncingMotion.x,this._bouncingMotion.y,this.options.icon.options.shadowSize[1],this._bouncingOptions.contractHeight)}}else{this._bouncingMotion.iconMovePoints=calculateIconMovePoints(this._bouncingMotion.x,this._bouncingMotion.y,this._bouncingOptions.bounceHeight);this._bouncingMotion.shadowMovePoints=calculateShadowMovePoints(this._bouncingMotion.x,this._bouncingMotion.y,this._bouncingOptions.bounceHeight,this._bouncingOptions.shadowAngle)}}});L.Marker.addInitHook(function(){this._bouncingMotion={isBouncing:!1,bouncingAnimationPlaying:!1};this._calculateTimeline()});var oldSetPos=L.Marker.prototype._setPos;var oldOnAdd=L.Marker.prototype.onAdd;var oldSetIcon=L.Marker.prototype.setIcon;var oldOn=L.Marker.prototype._on;L.Marker.prototype._setPos=function(pos){oldSetPos.call(this,pos);this._bouncingMotion.x=pos.x;this._bouncingMotion.y=pos.y;this._calculateTransforms()};L.Marker.prototype.onAdd=function(map){oldOnAdd.call(this,map);var styles=parseCssText(this._icon.style.cssText);delete styles[transform];delete styles['z-index'];styles.opacity=this.options.opacityWhenUnclustered||this.options.opacity||1;this._bouncingMotion.baseIconCssText=renderCssText(styles);if(this._shadow){styles=parseCssText(this._shadow.style.cssText);delete styles[transform];delete styles.opacity;this._bouncingMotion.baseShadowCssText=renderCssText(styles)}
this._bouncingMotion.bouncingAnimationPlaying=!1;if(this._bouncingMotion.isBouncing){this.bounce()}};L.Marker.prototype.setIcon=function(icon){oldSetIcon.call(this,icon);var styles={};if(this._icon){styles=parseCssText(this._icon.style.cssText);delete styles[transform];delete styles['z-index'];styles.opacity=this.options.opacityWhenUnclustered||this.options.opacity||1}
this._bouncingMotion.baseIconCssText=renderCssText(styles);if(this._shadow){styles=parseCssText(this._shadow.style.cssText);delete styles[transform];delete styles.opacity;this._bouncingMotion.baseShadowCssText=renderCssText(styles)}}},window))